
#include "WiFi_Routines.h"
#include "at_engine.h"
#include "hendler.h"

char ip_address[40];
sbit WIFI_3_EN         at RC2_bit;
sbit WIFI_3_EN_DIR     at TRISC2_bit;
sbit WIFI_3_RST        at RC1_bit;
sbit WIFI_3_RST_DIR    at TRISC1_bit;
int k = 0;

char tem_buffer[ 50 ];
volatile unsigned char     buffer[ 10240 ];
static T_AT_storage        storage[ 20 ];

void SistemInit()
{
     UART5_Init( 115200 );
     UART2_Init( 115200 );
     WIFI_3_EN_DIR = 0;
     WIFI_3_RST_DIR = 0;
     
     // tiimer init
     T1CON         = 0x8010;
     T1IP0_bit     = 1;
     T1IP1_bit     = 1;
     T1IP2_bit     = 1;
     T1IF_bit      = 0;
     T1IE_bit      = 1;
     PR1           = 10000;
     TMR1          = 0;
    
     // Uart init
     U2IP0_bit = 1;
     U2IP1_bit = 1;
     U2IP2_bit = 1;
     U2RXIE_bit = 1;
     EnableInterrupts();
     JTAGEN_bit = 0;
}

void WiFi_Init()
{
    WIFI_3_EN = 1;
    delay_ms(500);
    WIFI_3_RST = 0;
    delay_ms(500);
    WIFI_3_RST = 1;
    Delay_ms(5000);
}


void main() {
    SistemInit();
    DisplayInit();

    AT_initParser( UART2_Write, proba , 500, buffer, 10240, storage, 20 );
    AT_saveHandler( "+RST", 500, h_rst );
    AT_saveHandler( "+CWMODE", 500, h_mode );
    AT_saveHandler( "+CIPMUX", 500, h_mux );
    AT_saveHandler( "+CWJAP", 1500, h_jap );
    AT_saveHandler( "+CIPSTATUS", 500, h_status );
    AT_saveHandler( "+CIPSTO", 500, h_sto );
    AT_saveHandler( "+CIPSEND", 500, h_send );
    AT_saveHandler( "+IPD",  500, h_ipd );
    WiFi_Init();
    
    AT_cmdSingle( "AT+RST" );                                                  // Reset wifi module
    AT_cmdSingle( "AT+CWMODE=1" );                                               // Set wifi module 1: client, 2: AP, 3: client and AP
    AT_cmdSingle( "AT+CWJAP=\"MikroE Public\",\"mikroe.guest\"\r\n" );           // Conect wifi
    Delay_ms( 5000 );
    AT_cmdSingle( "AT+CIPSTATUS" ); 
    Delay_ms( 1000 );                                                            // Wifi status 2: conect on AP
    AT_cmdSingle( "AT+CIPMUX=1" );
    Delay_ms( 500 );                                                             // Wifi conections module 0: Single connection, 1: Multiple connections (MAX 4)
    AT_cmdSingle( "AT+CIPSERVER=1,80" );                                         // Configure as server 0: Delete server, 1: Create server
    Delay_ms( 500 );
    AT_cmdSingle( "AT+CIPSTO?" );                                                // Set server timeout
    memset(ip_address, 0, 16);
    AT_cmdSingle( "AT+CIFSR" );                                                  // Get local IP address ( ip: IP address of the ESP8266 as an client.b )
    Delay_ms( 5000 );
    AT_cmdSingle( "AT+CIPSEND" );                                                // Send data
    while( 1 )
    {
        AT_process();
    }

}

void Timer1Interrupt() iv IVT_TIMER_1 ilevel 7 ics ICS_SRS
{
    AT_tick();
    T1IF_bit  = 0;
}

/*
 *   UART Interrupt
 */
void RX_ISR() iv IVT_UART_2 ilevel 7 ics ICS_SRS
{
    if( IFS1 & ( 1 << U2RXIF ))
    {
        char tmp = UART2_Read();
        UART5_Write( tmp );
        AT_getChar( tmp );
        U2RXIF_bit = 0;
    }
}