
#include "WiFi_Routines.h"
#include "THERMO_Routines.h"
#include "MCP9600.h"
#include "at_engine.h"
#include "hendler.h"

sbit CH_PD            at RC2_bit;
sbit GPIO15           at  RC1_bit;
sbit CH_PD_Direction  at LATC2_bit;
sbit GPIO15_Direction at LATC1_bit;

char tem_buffer[ 50 ];
volatile unsigned char     buffer[ 10240 ];
static T_AT_storage        storage[ 20 ];

char ip_address[40];
unsigned short i;
char state;
char response_rcvd;
char responseID, response = 0;
char is_receiving_data = 0;
int cntr = 0;

char tk_status;
char txt[30];

char Temp_Data_Ready;
float fi;

sbit WIFI_3_EN         at RC2_bit;
sbit WIFI_3_EN_DIR     at TRISC2_bit;
sbit WIFI_3_RST        at RC1_bit;
sbit WIFI_3_RST_DIR    at TRISC1_bit;


void SistemInit(){

     I2C2_Init( 100000 );
     UART1_Init( 115200 );
     UART2_Init( 115200 );
     WIFI_3_EN_DIR = 0;
     WIFI_3_RST_DIR = 0;

     // tiimer init
     T1CON         = 0x8010;
     T1IP0_bit     = 1;
     T1IP1_bit     = 1;
     T1IP2_bit     = 1;
     T1IF_bit      = 0;
     T1IE_bit      = 1;
     PR1           = 10000;
     TMR1          = 0;

     // Uart init
     U2IP0_bit = 1;
     U2IP1_bit = 1;
     U2IP2_bit = 1;
     U2RXIE_bit = 1;
     EnableInterrupts();
     JTAGEN_bit = 0;
}


 // wifi esp
void WiFi_Init()
{
  WIFI_3_EN = 1;
  delay_ms(500);
  WIFI_3_RST = 0;
  delay_ms(500);
  WIFI_3_RST = 1;
  Delay_ms(2000);
  
}
// wifi 3 click
  void WiFi3_Init() {
   CH_PD_Direction = 0;          // Set Power down pin as output
   GPIO15_Direction = 0;         // Set GPIO15 pin as output
   CH_PD = 1;                    // Power down line at high level
   GPIO15 = 0;                   // GPIO15 pin at low level on module power-up
   Delay_ms(1000);
   GPIO15 = 1;             // wait five seconds on power-on
}

void main() {
    SistemInit();
    DisplayInit();

    AT_initParser( UART2_Write, proba , 500, buffer, 10240, storage, 20 );
    AT_saveHandler( "+RST", 1000, h_rst );
    AT_saveHandler( "+CWMODE", 1000, h_mode );
    AT_saveHandler( "+CIPMUX", 1000, h_mux );
    AT_saveHandler( "+CWJAP", 1000, h_jap );
    AT_saveHandler( "+CIPSTATUS", 500, h_status );
    AT_saveHandler( "+CIPSERVER", 500, h_server );
    AT_saveHandler( "+CIPSTO", 500, h_sto );
    WiFi3_Init();
    AT_cmdSingle( "AT+RST" );                                                    // Reset wifi module
    AT_cmdSingle( "AT+CWMODE=1" );                                               // Set wifi module 1: client, 2: AP, 3: client and AP
    AT_cmdSingle( "AT+CWJAP=\"MikroE Public\",\"mikroe.guest\"\r\n" );           // Conect wifi
    Delay_ms( 5000 );
    AT_cmdSingle( "AT+CIPSTATUS" );                                              // Wifi status 2: conect on AP
    AT_cmdSingle( "AT+CIPMUX=1" );                                               // Wifi conections module 0: Single connection, 1: Multiple connections (MAX 4)
    AT_cmdSingle( "AT+CIPSERVER=1,80" );                                         // Configure as server 0: Delete server, 1: Create server
    Delay_ms( 500 );
    AT_cmdSingle( "AT+CIPSTO?" );                                                // Set server timeout
    memset(ip_address, 0, 16);
    AT_cmdSingle( "AT+CIFSR" );                                                  // Get local IP address ( ip: IP address of the ESP8266 as an client.b )
    Delay_ms( 5000 );
    AT_cmdSingle( "AT+CIPSTATUS" );                                              // Test wifi status 2: conect on AP                                            // Send data
    AT_cmdSingle( "AT+CIPSTART=4,\"TCP\",\"10.101.22.132\",80" );
    
    while( 1 )
    {
        AT_process();
        tk_status = Read_MCP9600_Status();
        Temp_Data_Ready = ( tk_status & 0x40 );
        fi = Read_Temperature();
        sprintf(txt, "%2.2fC", fi );
        WiFi_Temp_Data( txt );
        Delay_ms(10000);
    }


}

void Timer1Interrupt() iv IVT_TIMER_1 ilevel 7 ics ICS_SRS
{
    AT_tick();
    T1IF_bit  = 0;
}

/*
 *   UART Interrupt
 */
void RX_ISR() iv IVT_UART_2 ilevel 7 ics ICS_SRS
{
    if( IFS1 & ( 1 << U2RXIF ))
    {
        char tmp = UART2_Read();
        UART1_Write( tmp );
        AT_getChar( tmp );
        U2RXIF_bit = 0;
    }
}