/*
Example for UV_3 Click

    Date          : Jun 2017.
    Author        : Danilo Milovic

Test configuration PIC32 :
    
    MCU             : P32MX795F512L
    Dev. Board      : EasyPIC Fusion v7
    SW              : mikroC PRO for PIC32 v3.6.1

Description :
     UV3 click is a simple solution for adding an ultraviolet light sensor to your design.
     It has VEML6070 UV sensor with digital output and thanks to the jumper it can work
     with 3.3V or 5V.
     Board specific: Turn on UARTB SW12.3 and SW12.4
*/


char uartTxt [20];

void systemInit()
{
    UART1_Init (115200);
    UART1_Write_Text ("\r\nInitializing...");
    I2C2_Init( 100000 );
    Delay_ms (100);
    UV_3_initDriver (0x70,I2C2_Start, I2C2_Stop, I2C2_Write, I2C2_Read);
    VEML6070_Init();
    UART1_Write_Text ("\r\nInitialized");
}

void main()
{
    systemInit();

    while( 1 )
    {
          UART1_Write_Text ("\r\nUV value: ");
          IntToStr (UV_3_read(), uartTxt);
          UART1_Write_Text (uartTxt);
          Delay_ms (750);
    }
}