
#include "WiFi_Routines.h"
#include "MCP9600.h"
#include "at_engine.h"
#include "hendler.h"

sbit CH_PD              at RB4_bit;
sbit GPIO15             at  RB2_bit;
sbit CH_PD_Direction    at LATB4_bit;
sbit GPIO15_Direction   at LATB2_bit;

volatile unsigned char     buffer[ 10240 ];
static T_AT_storage        storage[ 20 ];

int uv;
char tk_status;
char txt[30];

void SistemInit(){

   I2C2_Init( 100000 );      // inicialize I2C
   UART1_Init( 115200 );     // inicialize uart for read and test program
   UART2_Init( 115200 );     // inicialize UART for work WIFI

  /*
   *    timer init
   */
   T1CON         = 0x8010;
   T1IP0_bit     = 1;
   T1IP1_bit     = 1;
   T1IP2_bit     = 1;
   T1IF_bit      = 0;
   T1IE_bit      = 1;
   PR1           = 10000;
   TMR1          = 0;

  /*
   *    UART init
   */
   U2IP0_bit = 1;
   U2IP1_bit = 1;
   U2IP2_bit = 1;
   U2RXIE_bit = 1;
   EnableInterrupts();
   JTAGEN_bit = 0;
}

void WiFi3_Init()
{
   CH_PD_Direction = 0;                                                          // Set Power down pin as output
   GPIO15_Direction = 0;                                                          // Set GPIO15 pin as output
   CH_PD = 1;                                                                    // Power down line at high level
   GPIO15 = 0;                                                                   // GPIO15 pin at low level on module power-up
   Delay_ms(1000);
   GPIO15 = 1;                                                                   // wait five seconds on power-on
}

void main() 
{
    SistemInit();
    UV_3_initDriver (0x70,I2C2_Start, I2C2_Stop, I2C2_Write, I2C2_Read);
    VEML6070_Init();
    //UART1_Write_Text ("\r\nInitialized");
    
    AT_initParser( UART2_Write, proba , 500, buffer, 10240, storage, 20 );
    WiFi3_Init();
    AT_command_esp8266();
    
    while( 1 )
    {
        AT_process();
        uv = UV_3_read();
        sprintf(txt, "%dU", uv );
        WiFi_UV_Data( txt );
        Delay_ms(5000);
    }
}

/*
 *   Timer Interrupt
 */
void Timer1Interrupt() iv IVT_TIMER_1 ilevel 7 ics ICS_SRS
{
    AT_tick();
    T1IF_bit  = 0;
}

/*
 *   UART Interrupt
 */
void RX_ISR() iv IVT_UART_2 ilevel 7 ics ICS_SRS
{
    if( IFS1 & ( 1 << U2RXIF ))
    {
        char uv = UART2_Read();
        UART1_Write( uv );
        AT_getChar( uv );
        U2RXIF_bit = 0;
    }
}