#include "WiFi_Routines.h"
#include "at_engine.h"
#include "hendler.h"
#include "MCP9600.h"

char txt_val[ 60 ];
char data_[ 1000 ] = { 0 };
unsigned int length;
char ip_address[40];

void AT_command_esp8266()
{
/******************************************************************************
 *         AT Command |   Function           |    Response   |
 *          AT+RST    |   Reset the module   |      OK       |
*******************************************************************************/
    AT_cmdSingle( "AT+RST" );
    Delay_ms( 1000 );
/******************************************************************************
 *         AT Command    |   Function           |    Response   |
 *          AT+CWMODE    |   Set wifi module    |      OK       |
 *
 *  note: An integer designating the mode of operation either 1, 2, or 3.
 *         AT+CWMODE=1  ----  Station mode (client)
 *         AT+CWMODE=2  ----  AP mode (host)
 *         AT+CWMODE=3  ----  AP + Station mode (ESP8266 has a dual mode!)
*******************************************************************************/
    AT_cmdSingle( "AT+CWMODE=1" );
    Delay_ms( 1000 );
/******************************************************************************
 *         AT Command |   Function           |    Response   |
 *          AT+CWJAP  |   Connect to AP      |      OK       |
 *
 *   example: AT+CWJAP=SSID,PWD
 *            SSID: APs SSID (String)
 *            PWD:  APs Password (String)
*******************************************************************************/
    AT_cmdSingle( "AT+CWJAP=\"MikroE Public\",\"mikroe.guest\"\r\n" );
    Delay_ms( 5000 );
/******************************************************************************
 *     AT Command     |            Function              |    Response     |
 *    AT+CIPSTATUS    |   Information about connection   |  STATUS:status  |
 *
 *  note: rasponse status:
 *      * 2 -- Got IP
 *      * 3 -- Connected
 *      * 4 -- Disconnected
*******************************************************************************/
    AT_cmdSingle( "AT+CIPSTATUS" );
    Delay_ms( 1000 );
/******************************************************************************
 *     AT Command    |   Function                  |    Response   |
 *      AT+CIPMUX    |   Set multiple connections  |      OK       |
 *
 *  example:
 *        * AT+CIPMUX=0 --- Single connection
 *        * AT+CIPMUX=1 --- Multiple connections (MAX 4)
*******************************************************************************/
    AT_cmdSingle( "AT+CIPMUX=1" );
    Delay_ms( 1000 );
/******************************************************************************
 *         AT Command     |        Function         |    Response   |
 *        AT+CIPSERVER    |   Configure as server   |      OK       |
 *
 *  example:  AT+CIPSERVER=mode,port
 *     mode:
 *        * 0 --- Delete server
 *        * 1 --- Create server
 *     port:
 *        * port number
*******************************************************************************/
    AT_cmdSingle( "AT+CIPSERVER=1,80" );
    Delay_ms( 1000 );
/******************************************************************************
 *         AT Command    |   Function             |    Response      |
 *          AT+CIPSTO    |   Set server timeout   |   +CIPSTO:time   |
*******************************************************************************/
    AT_cmdSingle( "AT+CIPSTO?" );
    memset(ip_address, 0, 16);
    Delay_ms( 1000 );
/******************************************************************************
 *         AT Command    |   Function              |    Response      |
 *          AT+CIPSR     |   Get local IP address  |   +CIFSR:ip OK   |
*******************************************************************************/
    AT_cmdSingle( "AT+CIFSR" );
    Delay_ms( 5000 );
/******************************************************************************
 *     AT Command     |            Function              |    Response     |
 *    AT+CIPSTATUS    |   Information about connection   |  STATUS:status  |
 *
 *  note: rasponse status:
 *      * 2 -- Got IP
 *      * 3 -- Connected
 *      * 4 -- Disconnected
*******************************************************************************/
    AT_cmdSingle( "AT+CIPSTATUS" );
    Delay_ms( 1000 );
/******************************************************************************
 *    AT Command    |               Function              |    Response   |
 *   AT+CIPSTART    |    TCP connection or register UDP   |       OK      |
 *
 *  example:  AT+CIPSTART=ID,TYPE,ADDR,PORT
 *      ID   ---   0-4, id of connection
 *      TYPE ---   TCP or UDP (String)
 *      ADDR ---   Remote IP      (String)
 *      PORT ---   Remote port    (String)
*******************************************************************************/
    AT_cmdSingle( "AT+CIPSTART=4,\"TCP\",\"10.101.22.132\",80" );

}

static void WIFI_commend_string( const char* cmd )
{
    unsigned int i = 0;
    while( cmd[ i ] != 0 )
        UART2_Write( cmd[i++] );
}

void WiFi_UV_Data(char *temp )
{
    strcpy( data_ , temp );
    Rtrim( data_ );
    length = strlen( data_ );
    IntToStr( length , txt_val );
    Ltrim( txt_val );
    WiFi_send_data( "AT+CIPSEND=4," );
    Delay_ms(1000);
    strcpy(data_, "");
}

void WiFi_send_data(char *command )
{
     WIFI_commend_string(command);
     WIFI_commend_string( txt_val );
     UART2_Write(0x0D);
     UART2_Write(0x0A);
     Delay_ms(100);
     WIFI_commend_string( data_ );
     Delay_ms( 200 );
}